#define F_CPU 16000000
#include <avr/io.h>
#include <util/delay.h>
int main() {
	
	//Setez senzorii ca si date de intrare
	DDRA &= ~(1 << PA0);
	DDRA &= ~(1 << PA1);
	
	//Motoarele, date de iesire
    DDRD |= (1 << PD4); //Motor 1 ca input
    DDRD |= (1 << PD5);

    DDRD |= (1 << PD6); //Motor 2 ca input
    DDRD |= (1 << PD7);
 
 	//Buton, de intrare
 	DDRB &= ~(1 << PB2);

 	//Nu intru in program cat timp nu am apasat pe butonul PB2.
 	while ((PINB & (1 << PB2)) != 0) {

 	}
 
 	//Setez banda de timp pentru limitarea de viteaza
 	TCCR0B |= (1 << WGM02);
	TIMSK2 |= (1 << OCIE1B);
 	OCR0B = 255;

    while(1) {

    	//Am ajuns la final si raman pe loc.
    	if (!bit_is_clear(PINA, PA0) && !bit_is_clear(PINA, PA1)) {
    	 	while(1) {	
       		  	PORTD &= ~(1 << PD4); //Trimit semanal de pronire
       		  	PORTD &= ~(1 << PD5); //Opresc mersul inapoi
    	 		PORTD &= ~(1 << PD6); //Trimit semanal de pronire
       		  	PORTD &= ~(1 << PD7); //Opresc mersul inapoi
    	 	}
    	 
    	}

    	//Virez.
    	if (!bit_is_clear(PINA, PA1) && bit_is_clear(PINA, PA0)) {
			PORTD &= ~(1 << PD6); //Opresc mersul inainte
       		PORTD |= (1 << PD7); //Pornesc mersul inapoi
       		_delay_ms(150);
		}

    	//Virez.
    	if (!bit_is_clear(PINA, PA0) && bit_is_clear(PINA, PA1)) {
       		PORTD &= ~(1 << PD4); //Opresc mersul inainte
       		PORTD |= (1 << PD5); //Pornesc mersul inapoi
       		_delay_ms(150);
		}

		//Merg tot inainte.
    	if (bit_is_clear(PINA, PA1) && bit_is_clear(PINA, PA0)) {
        	PORTD |= (1 << PD4); //Trimit semanal de pronire
        	PORTD &= ~(1 << PD5); //Opresc mersul inapoi
     		PORTD |= (1 << PD6); //Idem ca sus
        	PORTD &= ~(1 << PD7);
       	}
    }
    return 0;
}